<?php
class ControllerUserQueues extends User{
    public function __construct() {
        parent::__construct();
    }

	public function list($f3) {
        try {
            $user = $f3->get('user');
            

            $results = $this->ModelQueues->findByUserId($user['id']);
                
            echo json_encode($results);

        } catch (Exception $exception){
            $f3->error(500, "Erro interno: " . $exception->getMessage());
        }		
	}


	public function view($f3) {
        try {
            $user = $f3->get('user');
            $queue_id = $_GET['queue_id'];
            
            $queue = $this->ModelQueues->findByUserIdAndQueueId($user['id'], $queue_id);

            if(!$queue) $f3->error(403, "Acesso aos dados negado!");
            
            $jobs = $this->ModelJobs->findByQueue($queue['name']);
        
            $data = array(
                'queue'=>$queue['name'],
                'jobs'=>$jobs
            );

            echo json_encode($data);


        } catch (Exception $exception){
            $f3->error(500, "Erro interno: " . $exception->getMessage());
        }		

	}
}
?>