<?php

class ModelClusters extends ModelBase {
    public function findClusterByQueueAndUserID($user_id, $queue){
        $sql = "SELECT clusters.url as url, clusters.token as token, clusters.name as name 
                FROM clusters
                LEFT JOIN queues ON queues.cluster_id = clusters.id
                LEFT JOIN clusters_permissions ON clusters_permissions.cluster_id = clusters.id
                LEFT JOIN projects ON projects.id = clusters_permissions.project_id
                LEFT JOIN projects_permissions ON projects_permissions.project_id = projects.id
                WHERE queues.name = '$queue' and projects_permissions.user_id = $user_id;
                ";

        $result = $this->DB->select(strval($sql));
        return $result->fetch_assoc();
    }

    public function findByJobId($job_id){
        $sql = "SELECT url, token, clusters.name as name FROM clusters
        LEFT JOIN queues on clusters.id = queues.cluster_id
        LEFT JOIN jobs on queues.name = jobs.queue
        WHERE jobs.id = $job_id";
        
        
        $result = $this->DB->select(strval($sql));
        return $result->fetch_assoc();

    }

    public function findByQueue($queue){
        $sql = "SELECT clusters.url as url, clusters.token as token, clusters.name as name FROM `clusters` 
                LEFT JOIN queues on queues.cluster_id = clusters.id
                WHERE queues.name = '$queue';";
        
        
        $result = $this->DB->select(strval($sql));
        return $result->fetch_assoc();

    }

    public function findAll(){
        $sql = "SELECT  clusters.id, 
                        clusters.name, 
                        clusters.url, 
                        clusters.token, 
                        count(clusters_permissions.project_id) as projects 
                FROM clusters
                LEFT JOIN clusters_permissions on clusters_permissions.cluster_id = clusters.id
                GROUP BY clusters.id, clusters.name, clusters.url, clusters.token;";


        $result = $this->DB->select(strval($sql));

        $list = array();
        while ($row = mysqli_fetch_assoc($result)) {
            array_push($list, $row);
        }
        
        return $list;
    }

    public function findByProjectId($project_id, $cluster_id) {
        $sql = "SELECT cluster_id 
                FROM clusters_permissions
                WHERE project_id = $project_id and cluster_id = $cluster_id;";

        $results = $this->DB->select(strval($sql));

        $list = array();
        while ($row = mysqli_fetch_assoc($results)) {
            array_push($list, $row);
        }
        
        return $list;
    }

    public function insertProject($cluster_id, $project_id){
        $sql = "INSERT INTO clusters_permissions (cluster_id, project_id) 
        VALUES ($cluster_id,$project_id);";


        $result = $this->DB->insert(strval($sql));
        return $result;
    }

    public function deleteProject($cluster_id, $project_id){
        $sql = "DELETE FROM clusters_permissions
                WHERE cluster_id = $cluster_id and project_id = $project_id;";

                
        $this->DB->updateN(array($sql));
    }


}
?>