# WebQueue - Back End

## Função

## Deploy

```yaml
version: "3.5"
services:
  back-end:
    image: registry.codigos.ufsc.br/setic-hpc/webqueue/back-end:latest
    environment:
        - GOOGLE_CLIENT_ID=
        - GOOGLE_CLIENT_SECRET=
        - PREFIX=/api
        - ORIGIN=
        - TOKEN=
        - DB_SERVER= #Endereço do banco de dados utilizado pelo slurm.
        - DB_USER= #Usuário do banco de dados utilizado pelo slurm.
        - DB_PASSWORD= #Senha do banco de dados utilizada pelo slurm.
        - DB_DB= #Banco de dados utilizado pelo slurm.

    ports:
        - 80:80
        
    deploy:
      placement: 
        constraints:
          - "node.hostname==node0"
```

## Configuração
