<?php
class ControllerAdminAdmins extends Admin{
    public function __construct() {
        parent::__construct();
    }

    public function put($f3) {
		try {
            $data = json_decode(file_get_contents('php://input'), true);
            $e_mail = $data['e_mail'];

            $user = $this->ModelUsers->find($columns=array('id','name','e_mail', 'admin'),$filters=array('e_mail'=>$e_mail));
            if(!$user) $f3->error(406, "O e-mail não está cadastrado no sistema!");

            $user = $user[0];

            if($user['admin'] == '1') $f3->error(423, "O usuário já é um administrador do sistema!");
            
            $values = array(
                'admin'=>'1',
            );

            $this->ModelUsers->update($values, $filters=array('id'=>$user['id']));
            
            echo json_encode($user);
		} catch (Exception $exception){
            $f3->error(500, "Erro interno!");
        }
    }

    public function delete($f3){
        try {
            $user = $f3->get('user');
            $user_id = $_GET['user_id'];

            if($user_id == $user['id']) $f3->error(423, "Você não pode fazer isso!");

            $values = array(
                'admin'=>'0',
            );

            $this->ModelUsers->update($values, $filters=array('id'=>$user_id));

        } catch (Exception $exception){
            $f3->error(500, "Erro interno!");
        }
    }

	public function list($f3) {
        try {
            $results = $this->ModelUsers->find($columns=array('id','name','e_mail'),$filters=array('admin'=>'1'));
                
            echo json_encode($results);

        } catch (Exception $exception){
            $f3->error(500, "Erro interno: " . $exception->getMessage());
        }		
	}


}
?>